#------------------------------------------------------------
#	2008/04/01
#	gTCD-ROM EPWING Toolkit
#	hishida
#------------------------------------------------------------

#	.epw2̍\
#------------------------------------------------------------
#	offset	length
#	------------------------------------------
#	0-2	[3]	"JKW"	0x4A4B57
#	3	[1]	Í Ƃ̔rI_aĺA4rbg = n(XLbv)
#	4	[n]	ϒ̕s
#	4+n	[t@C-4-n]	{BÍ Ƃ̔rI_aĂ
#			ɃS~L
#------------------------------------------------------------

require "setup.rb"
require "gaiji.rb"
require "FileUtils"

if File.exist?(SRCPATH+"/JetKW.jar")
	$magicCode	= 0x3B	# 2004N420@1
elsif File.exist?(SRCPATH+"/JETIXBN")
	$magicCode	= 0xA7	# 2007N119@2
elsif File.exist?(SRCPATH+"/html")
	$magicCode	= 0xA7	# 2007N119@2(JETIXBNs̏ꍇ)
else
	puts "gTłȂ߁A𒆎~܂"
	exit(-1)
end

#---------------------------------------------
#o̓fBNg̐
#---------------------------------------------
def makeDir()
	begin
	  Dir.mkdir(DESTPATH)
	rescue Errno::EEXIST
	  #ɃtH_݂
	end 
	begin
	  Dir.mkdir("gaiji")
	rescue Errno::EEXIST
	  #ɃtH_݂
	end
end

#---------------------------------------------
# gif𕡎ʂ
#---------------------------------------------
def copyImageFile()

	begin
	Dir.glob(SRCPATH+"/html/*.gif") {|fname|
		FileUtils.cp_r( fname, DESTPATH, {} )
	}
	rescue 
	end 

	begin
	Dir.glob(SRCPATH+"/gaiji/*.gif") {|fname|
		FileUtils.cp_r( fname, "gaiji", {} )
	}
	rescue 
	end 

end

#---------------------------------------------
#html/*.epw2  htmlɕϊ
#---------------------------------------------
def decrypt()
	Dir.glob(SRCPATH+"/html/*.epw2") {|fname|

		File::open(fname, 'rb') { |f|
			outfname = fname

			outfname.gsub!(/.*\/([a-zA-Z0-9_\-]*?)\.epw2/, DESTPATH+'/\1.html')
			File::open(outfname, 'w') { |outf|
				# wb_̃`FbN
				magic	= f.read(3)
				next if ! magic.match(/JKW/)
				# wb_̎cǂݔ΂
				str = f.read(1)
				b = str.unpack('C*')  # 1oCgPʂŏ
				nskip = ( ( b[0] ^ $magicCode ) & 0x0f )
				if nskip == 0 	
					nskip = 16
				end
				f.read( nskip )
				# {̕ϊ
				str = f.read
				b = str.unpack('C*')  # 1oCgPʂŏ
				b.collect! { |x| x ^ $magicCode }
				str =  b.pack('C*')
				# ̃S~폜
				str.gsub!(/<\/html>.*/,'</html>')
				outf.write( str )
			}

		}
	}

end


#---------------------------------------------
#	{EBStudiopHTMLɕϊ
#---------------------------------------------
class Honbun

    def convert( fname , outf )

	inBlock	= false
	File::open(fname, 'rb') { |f|
		str = f.read

		# svȗvf̏
		str.gsub!(/<html>/,	'')
		str.gsub!(/<\/html>/,	'')
		str.gsub!(/<head>.*<\/head>/,	'')
		str.gsub!(/<body.*?>/,	'')
		str.gsub!(/<\/body>/,	'')
		str.gsub!(/<a name="top">/,	'')
		str.gsub!(/<table.*?>.*?<\/table>/,	'')
		str.gsub!(/<\/p>/,	'</p>'+"\n" )
		str.gsub!(/<hr>/,	'')
		str.gsub!(/<br clear="all">/	,	'')

		str.gsub!(/<center><img border="0" src="html\/copyright.gif"\/><\/center>/,	'')

		# o
		str.gsub!(/<a name="(.*?)"><p><strong>(.*?)<\/strong>@([-E]*)/	,
				'</dd><dt id="\1">\2</dt> <dd><key type="">\3</key><sub>\3</sub>')

		# }ł̎QƊԈႢ𒼂
		str.gsub!(/pict_hon3.gif/,'pict_hon4.gif')	# \
		str.gsub!(/pict_hon2.gif/,'pict_hon3.gif')	# O֐g

		# {Q
		str.gsub!(/<a href='javascript:JetKWLinkCryptoX\("html\/[0-9]*?\.JKW","#([A-Z0-9]*?)"\)'>(.*?)<\/a>/	,'<a href="#\1">\2</a>')

		# t^Q
		str.gsub!(/<a href='javascript:JetKWLinkCryptoX\("html\/(furoku[0-9_\-]*?)\.JKW","#top"\)'>(.*?)<\/a>/	,'<a href="furoku.html#\1">\2</a>')

#	<a href='javascript:JetKWLinkCryptoX("html/furoku8.JKW","#top")'>t(@z2</a>)

		# ̎QƂ̒u
		str.gsub!(/<([--꤁[E\(\)\-]*?)>/,	'&lt;\1&gt;' )
		str.gsub!(/<([--꤁[E\(\)])/,	'&lt;\1' )
		str.gsub!(/([--꤁[E\(\)])>/,	'\1&gt;' )
		str.gsub!(/>>/,'>&gt;')
		str.gsub!(/<</,'&lt;<')

		str.gsub!(/<(<a href=".*?">.*?<\/a>)>/,	'&lt;\1&gt;' )
#			str.gsub!(/<p><p>/,	'<p>' )
		str.gsub!(/<br><\/dd>/,	'</dd>' )

		# o
		str.gsub!(/<font color="green">(.*?)<\/font>/,	'<b>y\1z</b>')
		# O
		str.gsub!(/<img align=".*?" border="0" width="14" height="14" alt="" src="gaiji\/([0-9a-zA-Z]*?).gif"[\/]*>/,	'<img src="gaiji/\1.jpg" class="inline">')
		GaijiMap.each {|k,v|
			if v!=""
				str.gsub!( /<img src="gaiji\/#{k}.jpg" class="inline">/ , "#{v}" )
			end
		}

		# pL[̒ǉ
		str.gsub!(/mp:(.+?)n/,	'mp:\1n<key type="\L">\1</key>')
		str.gsub!(/ms:(.+?)n/,	'ms:\1n<key type="\L">\1</key>')
		str.gsub!(/m([a-zA-Z&#;\- ]+?)n/,	'm\1n<key type="\L">\1</key>')

		# 摜
		str.gsub!(/<img border="0" src="html\/(.*?).gif"\/>/,	'<img src="html/\1.jpg">')

		outf.write str
	}

    end

end

#---------------------------------------------
#	t^Aj[AAwvEBStudiopHTMLɕϊ
#---------------------------------------------
class Appendix

def convert( fname , outf )

	File::open(fname, 'rb') { |f|
		id	= fname.gsub(/.*\/(.*?)\.html/,'\1')
		str = f.read

		outf.puts "<X4081>1F02</X4081>"	#\Jn

		# svȗvf̏
		str.gsub!(/<html>/,	'')
		str.gsub!(/<\/html>/,	'')
		str.gsub!(/<head>.*<\/head>/,	'')
		str.gsub!(/<body.*?>/,	'')
		str.gsub!(/<\/body>/,	'')
		str.gsub!(/<\/p>/,	'</p>'+"\n" )
		str.gsub!(/<hr>/,	'')
		str.gsub!(/<a href=".*?" onclick="javascript:JetKWHistoryBack(); return false;"><img src="html\/goback.gif" align="right" border="0"\/><\/a>/,	'')

		str.gsub!(/<a href=.*?><img src="html\/goback.gif" align="right" border="0"\/><\/a>/,'')

		str.gsub!(/\t/,'')
		str.gsub!(/<br><br>/,'<br>')
#		str.gsub!(/<td>/,'<td><br>')

		# o
		str.gsub!(/<a name="top">/,	'<a name="'+id+'"></a>')
		str.gsub!(/<font.*?>(.*?)<\/font>/,	'<p><b>\1</b></p>')

		# {Q
		str.gsub!(/<a href='javascript:JetKWLinkCryptoX\("html\/[0-9]*?\.JKW","#([A-Z0-9]*?)"\)'>(.*?)<\/a>/	,'<a href="bukkyo2.html#\1">\2</a>')

		# t^Q
		str.gsub!(/<a href='javascript:JetKWLinkCryptoX\("html\/(furoku[a-zA-Z0-9_\-]*?)\.JKW","#top"\)'>(.*?)<\/a>/	,'<a href="furoku.html#\1">\2</a>')
		str.gsub!(/<a href='javascript:JetKWLinkCryptoX\("html\/(menu[a-zA-Z0-9_\-]*?)\.JKW","#top"\)'>(.*?)<\/a>/	,'<a href="menu.html#\1">\2</a>')
		str.gsub!(/<a href='javascript:JetKWLinkCryptoXF2\("html\/(sakuin[a-zA-Z0-9_\-]*?)\.JKW","#top"\)'>(.*?)<\/a>/	,'<a href="sakuin.html#\1">\2</a>')

		str.gsub!(/<a href='javascript:JetKWLinkCryptoX\("html\/(help[a-zA-Z0-9_\-]*?)\.JKW","#top"\)'>(.*?)<\/a>/	,'<a href="help.html#\1">\2</a>')

		str.gsub!(/<([--\(\)]*?)>/,	'&lt;\1&gt;' )
		str.gsub!(/<(<a href=".*?">.*?<\/a>)>/,	'&lt;\1&gt;' )

		# o
		str.gsub!(/<font color="#880000" size="+2">(.*?)<\/font>/,	'<p><b>\1</b></p>')
		# O
		str.gsub!(/<img align=".*?" border="0" width="14" height="14" alt="" src="gaiji\/([0-9a-zA-Z]*?).gif"[\/]*>/,	'<img src="gaiji/\1.jpg" class="inline">')
		GaijiMap.each {|k,v|
			if v!=""
				str.gsub!( /<img src="gaiji\/#{k}.jpg" class="inline">/ , "#{v}" )
			end
		}

		# 摜
		str.gsub!(/<img src="html\/(.*?).gif".*?\/>/,	'<img src="html/\1.jpg">')
		str.gsub!(/<img src="html\/(.*?).gif".*?>/,	'<img src="html/\1.jpg">')

		# ʒu
		str.gsub!(/(<tr><td width="[0-9]+?"><\/td><td>)/,'\1<br>')

		outf.write str

		outf.puts "<br>"

		outf.puts "<X4081>1F03</X4081>"	#\I

	}

end
end

#------------------------------------------------------------
class EBSFile < File

File.expand_path(__FILE__) 

  def print(inPath,outPath)
    puts <<"--------"
InPath=#{inPath.gsub(/\//, '\\') + '\\'}
OutPath=#{outPath.gsub(/\//, '\\')}
IndexFile=
Copyright=$(BASE)\\copyright.txt
GaijiFile=$(BASE)\\Gaiji.xml
GaijiMapFile=$(BASE)\\GaijiMap.xml
EBType=0
MenuSearch=1
WordSearchHyoki=1
WordSearchKana=1
EndWordSearchHyoki=1
EndWordSearchKana=1
KeywordSearch=1
CrossSearch=0
ComplexSearch=0
topMenu=1
singleLine=0
kanaSep1=y
kanaSep2=z
hyokiSep=1
makeFig=1
inlineImg=0
paraHdr=0
ruby=1
paraBr=0
subTitle=0
dfnStyle=0
srchUnit=0
linkChar=0
arrowCode=222A
eijiPronon=1
eijiPartOfSpeech=1
eijiBreak=1
eijiKana=0
eijiYomi=0
leftMargin=1
indent=0
tableWidth=480
StopWord=a the
delBlank=1
delSym=1
delChars=wx
refAuto=1
titleWord=1
autoWord=0
autoEWord=0
HTagIndex=1
HTagMenu=1
delLeadNo=0
DTTagIndex=1
dispKeyInSelList=0
titleOrder=0
omitHeader=0
addKana=1
autoKana=0
kwordLen=1
typeCplxKwd=0
pdicTitle=0
pdicPronon=1
pdicHonbun=0
pdicYorei=0
withHeader=0
optMono=0
Size=50000;10000;4000;7000000;4000;50000;50000;14500;500;10000;2000
Book=gT;BUKKYO2;ʏ;_;_;GAI16H00;GAI16F00;_;_;_;_;_;_;
Source=$(BASE)\\bukkyo2.html;gT;_;HTML;
Source=$(BASE)\\index.html;j[;_;HTML;
Source=$(BASE)\\sakuin.html;;_;HTML;
Source=$(BASE)\\furoku.html;(t)};_;HTML;
Source=$(BASE)\\menu.html;e[}ڈꗗ;_;HTML;
Source=$(BASE)\\html\\idb2e_copyright.html;쌠;_;HTML;
Source=$(BASE)\\help.html;wv;_;HTML;
Source=$(BASE)\\cover.html;\;_;HTML;
--------
  end
end


#---------------------------------------------
# main
#---------------------------------------------

start = Time::now
STDERR.print "Jn: ", start.strftime('%Y-%m-%d %X'), "\n"

makeDir()	# o̓fBNg̍쐬
copyImageFile()	# gift@C̕
decrypt()	# ϊ̎s
cnv = Honbun::new

# {̕ϊ
outfname	= "bukkyo2.html"
File::open(outfname, 'w') { |outf|

	outf.puts '<html>'
	outf.puts '<head><title>gT</title></head>'
	outf.puts '<body>'
	outf.puts '<dl>'
	outf.puts '<dd>'

	for i in 0..272
		fname = "html/" + i.to_s + ".html"
		cnv.convert( fname, outf )
	end

	outf.puts '</dd>'
	outf.puts '</dl>'
	outf.puts '</body>'
	outf.puts '</html>'
}

cnv2 = Appendix::new
# t^̕ϊ
outfname	= "furoku.html"
File::open(outfname, 'w') { |outf|
	outf.puts '<html><head><title>gT</title></head><body>'

	Dir.glob(DESTPATH+"/furoku*.html") {|fname|
		cnv2.convert( fname, outf )
	}
	outf.puts '</body></html>'

}

# j[̕ϊ
outfname	= "menu.html"
File::open(outfname, 'w') { |outf|
	outf.puts '<html><head><title>gT</title></head><body>'
	Dir.glob(DESTPATH+"/menu*.html") {|fname|
		cnv2.convert( fname, outf )
	}
	outf.puts '</body></html>'

}
# ̕ϊ
outfname	= "sakuin.html"
File::open(outfname, 'w') { |outf|
	outf.puts '<html><head><title>gT</title></head><body>'

	Dir.glob(DESTPATH+"/sakuin*.html") {|fname|
		cnv2.convert( fname, outf )
	}
	outf.puts '</body></html>'
}
# wv̕ϊ
outfname	= "help.html"
File::open(outfname, 'w') { |outf|
	outf.puts '<html><head><title>gT</title></head><body>'

	Dir.glob(DESTPATH+"/help*.html") {|fname|
		cnv2.convert( fname, outf )
	}
	outf.puts '</body></html>'
}

# ebst@C̍쐬
ebsFile = 'bukkyo2.ebs'
EBSFile::open(ebsFile,'w') { |ebsf|
  inPath = File.expand_path(__FILE__)
  inPath.gsub!(/\/[a-zA-Z0-9_]+\.rb$/,'')
  ebsf.print( inPath,EPWINGPATH)
}

finish = Time::now
STDERR.print "I: ", finish.strftime('%Y-%m-%d %X'), "\n"
STDERR.print ": ", Time::at(finish.to_i - start.to_i).utc.strftime('%X'), "\n"

#--------------------------------------
exit(0)


